#!/bin/bash

# Set sane defaults
IFS=$' \t\n'
export LANG=C
export LC_NUMERIC=C
export LC_TIME=C

syntax()
{
  printf 'Usage: op5 log range <timestamp1> [timestamp2]\n'
  exit $1
}

[ -n "$1" ] || syntax 1
[ "$1" == '-h' ] && syntax 0
[ "$1" == '--help' ] && syntax 0

ts()
{
  if [ "$1" -ge '0' ] &> /dev/null; then
    ts="$1"
  else
    ts="$(date -d "$1" +%s)" || exit 1
  fi
}

ts "$1"
query='$2 >= '"$ts"

if [ -n "$2" ]; then
  ts "$2"
  query+=' && $2 <= '"$ts"
fi

awk -F'[][]' "$query"
